package com.supermap.sample.temperature;

import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.core.Context;

import com.supermap.services.InterfaceContext;
import com.supermap.services.rest.HttpException;
import com.supermap.services.rest.Template;
import com.supermap.services.rest.commontypes.Component;
import com.supermap.services.rest.resources.JaxrsResourceBase;

@Path("/")
//申明该资源需要使用的业务组件
//Declare the business components the resource needs to use
@Component(interfaceClass = Temperature.class)
public class TemperatureResource extends JaxrsResourceBase {
	@GET
	@Template(name = "temperatureForm.ftl")
	public Map<String, String> getGetForm(@Context HttpServletRequest request) {
		String url = request.getRequestURL().toString();
		Map<String, String> variables = new HashMap<String, String>();
		variables.put("url", url);
		return variables;
	}

	@GET
	@Path("{cityname}")
	@Template(name = "temperature.ftl")
	public String getMapImageURI(
			@PathParam("cityname") String cityname,
			@Context HttpServletRequest request) {
		if (cityname == null) {
			throw new HttpException(400, "Argument keyWord can not be null");
		}
		try {
			cityname = URLDecoder.decode(cityname, "utf-8");
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		//获取温度组件
		//Get the Temperature component
		InterfaceContext interfaceContext=super.getInterfaceContext();
		List<Temperature> tempratureComponents=interfaceContext.getComponents(Temperature.class);
		Temperature tempratureComponent=tempratureComponents.get(0);
//		Temperature tempratureComponent=interfaceContext.getComponents(Temperature.class).get(0);
		//图片URI
		//Picture URI
		String imageURL=tempratureComponent.getMapImage(cityname);
		//对服务器端口处理
		//Process the server port
		String port=String.valueOf(request.getServerPort());
		imageURL=imageURL.replace("{port}", port);
		imageURL=imageURL.replace("{ip}", request.getServerName());

		//返回处理后的图片URI
		//Return the processed picture URI
		return imageURL;
	}
}
